/* 
 This file was generated by Dashcode.  
 You may edit this file to customize your widget or web page 
 according to the license.txt file included in the project.
 */

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    dashcode.setupParts();
    ckgInit();

	var scrollArea = document.getElementById("scrollArea"),
		obj = document.getElementById( "Alphagraph" ),
		attr;
	if ( obj )
		scrollArea.object.content.removeChild( obj );

	obj = document.createElement( "p" );
	obj.appendChild( document.createTextNode( "© 2010 Christian Gottschall" ) );

	attr = document.createAttribute( "id" );
	attr.nodeValue = "Alphagraph";
	obj.setAttributeNode( attr );
	attr = document.createAttribute( "align" );
	attr.nodeValue = "center";
	obj.setAttributeNode( attr );
	
	scrollArea.object.content.appendChild( obj );
	scrollArea.object.refresh();    
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}


/**********************************************************************************************/



/*
    (C) Christian Gottschall
    
    März 2010
    
    Alle Rechte - einschließlich derer der Vervielfältigung,
    Übersetzung und Verfilmung - vorbehalten.
*/


var CGWTAB = {
    verum:"1",
    falsum:"0",
    oldView:1,          // sichtbare Ebene vor Optionsdialog
    optimize:1,         // Ausdrücke optimieren
    val_stapel:[],
    op_stapel:[],
    processMenu:null,
    clearMenu:null,
    settingsMenu:null,
    examplesMenu:null,
    inputMenu:null,	// 5
    backspaceMenu:null,
    letterMenu:null,    // 6
    connMenu:null,
    bracketMenu:null,
    helpMenu:null,
    infixzeichen:"&^v|-~=>()!¡%",
    beispiele:[
       "P&Q",
       "PvQ",
       "P>Q",
       "P=Q",
       "Pv-P",
       "-(P&-P)",
       "-(P&-Q)",
       "P>(Qv-R)",
       "(P>Q)v(Q>R)",
       "ACpqCqp",
       "CCpCqrCCpqCpr",
       "ApNp",
       "NKpNp",
       "P&Q&R&S&T&U",
       "PvQvRvSvT"
    ],
    eingaben:[
        "textNicht",
        "textUnd",
        "textOder",
        "textPfeil",
        "textDoppelpfeil",
        "textXOR",
        "textNOR",
        "textNAND",
        "text(",
        "text)"
    ],
    eingabedaten:[
        "-",
        "&",
        "v",
        ">",
        "=",
        "%",
        "!",
        "¡",
        "(",
        ")"
    ],
    satzbuchstaben:[
        "buchstP",
        "buchstQ",
        "buchstR",
        "buchstS",
        "buchstT",
        "buchstU",
        "buchstW"
    ],
    satzbuchstabentext:[
        "P",
        "Q",
        "R",
        "S",
        "T",
        "U",
        "W"
    ],
    crarr: 8594, srarr: "",
    charr: 8596, sharr: "",
    cand: 8743, sand: "",
    cor: 8744, sor: "",
    cnot: 172, snot: "",
    cuarr: 8593, suarr: "",
    cdarr: 8595, sdarr: ""
};


function ckgInit()
{
    CGWTAB.srarr = String.fromCharCode( CGWTAB.crarr );
    CGWTAB.sharr = String.fromCharCode( CGWTAB.charr );
    CGWTAB.suarr = String.fromCharCode( CGWTAB.cuarr );
    CGWTAB.sdarr = String.fromCharCode( CGWTAB.cdarr );
    CGWTAB.sand = String.fromCharCode( CGWTAB.cand );
    CGWTAB.sor = String.fromCharCode( CGWTAB.cor );
    CGWTAB.snot += String.fromCharCode( CGWTAB.cnot );

    CGWTAB.infixzeichen += CGWTAB.srarr;
    CGWTAB.infixzeichen += CGWTAB.sharr;
    CGWTAB.infixzeichen += CGWTAB.suarr;
    CGWTAB.infixzeichen += CGWTAB.sdarr;
    CGWTAB.infixzeichen += CGWTAB.sand;
    CGWTAB.infixzeichen += CGWTAB.sor;
    CGWTAB.infixzeichen += CGWTAB.snot;

    CGWTAB.verum = getMessage("wahr")
    CGWTAB.falsum = getMessage("falsch")
}


function getMessage(key)
{
    var ret = localizedStrings[key];
    if (ret === undefined)
        ret = key;
    return ret;
}


function uebernehmen(event)
{
    var aussageObj = document.getElementById("aussage"),
        aussage = aussageObj.value,
        scrollArea = document.getElementById("scrollArea"),
        eingabebereich = document.getElementById("eingabebereich"),
        ausgabebereich = document.getElementById("ausgabebereich"),
        infix = 0, praefix = 0, i, c, graph;

    try
    {
        for ( i = 0; i < aussage.length; i++ )
        {
            c = aussage.charAt( i );
            if ( "NKACE".indexOf(c) > 0 )
                praefix++;
            else if ( CGWTAB.infixzeichen.indexOf(c) > 0 )
                infix++;
        }
        
        graph = document.getElementById( "Alphagraph" );
        if ( graph )
        {
            try
            {
                scrollArea.object.content.removeChild( graph );
                delete graph;
            }
            catch( e )
            {
            }
        }
            
        graph = alphagraph(aussage, infix >= praefix);

        
        var attr = document.createAttribute( "id" );
        attr.nodeValue = "Alphagraph";
        graph.setAttributeNode( attr );
        
        graph.style.textAlign = "center";

		scrollArea.object.content.appendChild( graph );
		scrollArea.object.refresh();


        if ( infix >= praefix )
        {
            aussage = verschoenern( aussage );
            aussageObj.value = aussage;
        }

    }
    catch( e )
    {
		var obj = document.getElementById( "Alphagraph" );
		if ( obj )
			scrollArea.object.content.removeChild( obj );

		obj = document.createElement( "p" );
		obj.appendChild( document.createTextNode( e ) );

		attr = document.createAttribute( "id" );
		attr.nodeValue = "Alphagraph";
		obj.setAttributeNode( attr );
		
		scrollArea.object.content.appendChild( obj );
		scrollArea.object.refresh();
    }
}


function istKleinbuchstabe( c )
{
    return c === c.toLowerCase() && c !== c.toUpperCase();
}


function istGrossbuchstabe( c )
{
    return c === c.toUpperCase() && c !== c.toLowerCase();
}


function istBuchstabe( c )
{
    return istKleinbuchstabe(c) || istGrossbuchstabe(c);
}


function alphagraph( aussage, infix )
{
     if ( CGWTAB.optimize )
         return praefixAlpha( infix ? infix2prefix(aussage) : aussage );
     else
         return (infix ? infixAlpha : praefixAlpha)( aussage );
}


function push_val( wert )
{
    CGWTAB.val_stapel[CGWTAB.val_stapel.length] = wert;
}


function pop_val()
{
    if ( ! CGWTAB.val_stapel || CGWTAB.val_stapel.length < 1 )
        throw getMessage("Stapelunterlauf");
    var wert = CGWTAB.val_stapel[ CGWTAB.val_stapel.length - 1 ];
    CGWTAB.val_stapel.length = CGWTAB.val_stapel.length - 1;
    return wert;
}


function peek_val()
{
    if ( ! CGWTAB.val_stapel || CGWTAB.val_stapel.length < 1 )
        throw getMessage("Stapelunterlauf");
    var wert = CGWTAB.val_stapel[ CGWTAB.val_stapel.length - 1 ];
    return wert;
}


function push_op( wert )
{
    CGWTAB.op_stapel[CGWTAB.op_stapel.length] = wert;
}


function pop_op()
{
    if ( ! CGWTAB.op_stapel || CGWTAB.op_stapel.length < 1 )
        throw getMessage("Stapelunterlauf");
    var wert = CGWTAB.op_stapel[ CGWTAB.op_stapel.length - 1 ];
    CGWTAB.op_stapel.length = CGWTAB.op_stapel.length - 1;
    return wert;
}


function peek_op()
{
    if ( ! CGWTAB.op_stapel || CGWTAB.op_stapel.length < 1 )
        throw getMessage("Stapelunterlauf");
    return CGWTAB.op_stapel[ CGWTAB.op_stapel.length - 1 ];
}


function op_avail()
{
    return CGWTAB.op_stapel.length > 0;
}


function praefixAlpha( aussage, bewertung, konstanten )
{
    var i, c, p, q, resultat;
    CGWTAB.val_stapel.length = 0;
    try
    {
        for ( i = aussage.length-1; i >= 0; i-- )
        {
            c = aussage.charAt(i);
            switch( c )
            {
                case "1":   push_val( do_positiv("1") ); break;
                case "0":   push_val( do_positiv("0") ); break;
                case 'N':   p = pop_val(); push_val( do_negation( p ) ); break;
                case "C":   p = pop_val(); q = pop_val();
                            push_val( do_konditional( p, q ) );
                            break;
                case 'E':   p = pop_val(); q = pop_val();
                            push_val( p && q || !p && !q );
                            push_val( do_disjunktion( do_konjunktion( p, q ),
                                                      do_konjunktion( do_negation(p),
                                                                      do_negation(q) ) ) );
                            break;
                case 'K':   p = pop_val(); q = pop_val();
                            push_val( do_konjunktion( p, q ) ); break;

                case 'A':   p = pop_val(); q = pop_val();
                            push_val( do_disjunktion( p, q ) );
                            break;

                default:    if ( ! istKleinbuchstabe(c) )
                                throw getMessage("Unerlaubtes Zeichen") +
                                      " \"" + c + "\".";
                            push_val( do_positiv( c ) );
                            break;
            }
        }
        resultat = pop_val();
        if ( CGWTAB.val_stapel.length !== 0 )
            throw getMessage("Stapel wird nicht leer");
        return resultat;
    }
    catch( e )
    {
        throw e;
    }
    finally
    {
        CGWTAB.val_stapel = [];
    }
}


function pruefePraefixAussage(aussage)
{
    var i, c, sp;
    if ( aussage.length === 0 ) return false;
    for ( i = aussage.length-1, sp = 0; i >= 0; i-- )
    {
        c = aussage.charAt(i);
        switch( c )
        {
            case '1': case "0":     sp++; break;
            case 'N':               if ( sp < 1 )
                                        return false;
                                    break;
            case "C": case 'E':
            case 'K': case 'A':     if ( sp < 2 )
                                        return false;
                                    sp--; break;
            default:                if ( ! istKleinbuchstabe(c) )
                                        return false;
                                    sp++; break;
        }
    }
    return sp === 1;
}


function op_prio(op)
{
    switch(op)
    {
        case CGWTAB.snot: case "-": case "~":   return 1;
        case "!": case "&": case "^":
        case CGWTAB.sand: case CGWTAB.suarr:    return 2;
        case "v": case "|": case "%": case "¡":
        case CGWTAB.sor: case CGWTAB.sdarr:     return 3;
        case ">": case "->": case "=>":
        case "-->" : case "==>":
        case CGWTAB.srarr:                      return 4;
        case "=": case CGWTAB.sharr:            return 5;
        case ")":                               return 6;
        default: throw getMessage("Unbekannter Operator") + " \"" + op + "\".";
    }
    return-1;
}


function do_positiv(s)
{
    var p = document.createElement( "span" ),
        attr = document.createAttribute( "class" );
    attr.nodeValue = "alphaKnoten";
    p.setAttributeNode( attr );
    p.appendChild( document.createTextNode( s.toUpperCase() ) );
    return p;
}


function do_negation(n)
{
    var p = document.createElement( "span" ),
        attr = document.createAttribute( "class" );
    attr.nodeValue = "alphaKnotenNegiert";
    p.setAttributeNode( attr );
    p.appendChild( n );
    return p;
}


function do_konjunktion(a,b)
{
    var p = document.createElement( "span" ),
        attr = document.createAttribute( "class" );
    attr.nodeValue = "alphaKnoten";
    p.setAttributeNode( attr );
    p.appendChild( a );
    p.appendChild( b );
    return p;
}


function do_disjunktion(a,b)
{
    return do_negation( do_konjunktion( do_negation(a), do_negation(b) ) );
}


function do_konditional(a,b)
{
    var p = document.createElement( "span" ),
        attr = document.createAttribute( "class" );
    attr.nodeValue = "alphaKnoten";
    p.setAttributeNode( attr );
    p.appendChild( a );

    return do_negation( do_konjunktion( p, do_negation( b ) ) );
}


function do_op()
{
    var op = pop_op(), p, q;
    switch(op)
    {
        case CGWTAB.snot: case "-": case "~":
            p = pop_val(); push_val( do_negation( p ) ); break;
        case CGWTAB.sdarr: case "!":
            p = pop_val(); q = pop_val();
            push_val( do_negation( do_disjunktion( p, q ) ) );
            break;
        case CGWTAB.suarr: case "¡":
            p = pop_val(); q = pop_val();
            push_val( do_negation( do_konjunktion( p, q ) ) );
            break;
        case "%":
            p = pop_val(); q = pop_val();
            push_val( do_disjunktion( do_konjunktion( p, do_negation(q) ),
                                      do_konjunktion( do_negation(p), q ) ) );
            break;
        case "=": case CGWTAB.sharr:
            p = pop_val(); q = pop_val();
            push_val( do_disjunktion( do_konjunktion( p, q ),
                                      do_konjunktion( do_negation(p), do_negation(q) ) ) );
            break;
        case "&": case "^": case CGWTAB.sand:
            p = pop_val(); q = pop_val(); push_val( do_konjunktion( p, q ) ); break;
        case "v": case "|": case CGWTAB.sort:
            p = pop_val(); q = pop_val(); push_val( do_disjunktion( p, q ) ); break;
        case ">": case "->": case "=>": case "-->" : case "==>":
        case CGWTAB.srarr:
            p = pop_val(); q = pop_val(); push_val( do_konditional( p, q ) ); break;
        case ")":
            throw getMessage("Zu viele geschlossene Klammern");
        default:
            throw getMessage("OP-Fehler") + "\"" + CGWTAB.op_stapel + "\"" +
                  ", op=\"" + op + "\".";
    }
}


function infixAlpha( aussage )
{
    var i, c, p, q, resultat, o, attr;
    CGWTAB.val_stapel.length = 0;
    CGWTAB.op_stapel.length = 0;
    try
    {
        for ( i = aussage.length-1; i >= 0; i-- )
        {                
            c = aussage.charAt(i);
            switch( c )
            {

                case " ":
                    break;
                    
                case "-": case "~": case CGWTAB.snot:
                case "!": case CGWTAB.sdarr:
                case "¡": case CGWTAB.suarr:
                case "%": case "=": case CGWTAB.sharr:
                case "&": case "^": case CGWTAB.sand:
                case "v": case "|": case CGWTAB.sor:
                case ">": case "->": case "=>": case "-->" : case "==>":
                case CGWTAB.srarr:
                    if ( c === ">" && i > 0 )
                    {
                        var d = aussage.charAt( i - 1 );
                        if ( (d === '-' || d === '=') && --i > 0 )
                        {
                            var e = aussage.charAt( i - 1 );
                            if ( e === d )
                            {
                                if ( --i > 0 && ((d = aussage.charAt(i-1)) === '-' ||
                                                 d === '=') )
                                    throw getMessage("Konditionalfehler") +
                                          (i+1);
                            }
                            else if ( e === "-" || e === "=" )
                                throw getMessage("Konditionalfehler") +
                                      (i+1);
                        }
                    }
                    if ( op_avail() && op_prio( peek_op() ) < op_prio( c ) )
                        do_op();
                    push_op( c );
                    break;
                case ")":
                    push_op( c );
                    break;
                case "(":
                    while( peek_op() !== ")" )
                        do_op();
                    if ( pop_op() !== ")" )
                        throw getMessage("Klammer zu erwartet");
                    break;
                default:
                    if ( ! istBuchstabe(c) && c !== '0' && c !== '1' )
                        throw getMessage("Unerlaubtes Zeichen") + " \"" + c + "\".";
                    push_val( do_positiv( c ) );
                    break;
            }
        }
        while( op_avail() )
            do_op();
        resultat = pop_val();
        if ( CGWTAB.val_stapel.length !== 0 || CGWTAB.op_stapel.length !== 0 )
            throw getMessage("Stapel wird nicht leer");
        return resultat;
    }
    catch( e )
    {
        throw e;
    }
    finally
    {
        CGWTAB.val_stapel = [];
        CGWTAB.op_stapel = [];
    }
}


function verschoenern( aussage )
{
    var schoen = aussage.toUpperCase().replace( /V/g, "v" );
    schoen = schoen.replace( /--?>/g, CGWTAB.srarr );
    schoen = schoen.replace( /==?>/g, CGWTAB.srarr );
    schoen = schoen.replace( />/g, CGWTAB.srarr );
    schoen = schoen.replace( /[v|]/g, "v" /* String.fromCharCode(cor) */ );
    schoen = schoen.replace( /[&^]/g, "&" /* String.fromCharCode(cand) */ );
    schoen = schoen.replace( /=/g, CGWTAB.sharr );
    schoen = schoen.replace( /!/g, CGWTAB.sdarr );
    schoen = schoen.replace( /¡/g, CGWTAB.suarr );
    schoen = schoen.replace( /[~-]/g, CGWTAB.snot );
    return schoen;
}


function do_infix2praefix_disjunktion( p, q )
{
    var np = p.charAt(0) === "N" ? p.substr( 1 ) : "N" + p,
        nq = q.charAt(0) === "N" ? q.substr( 1 ) : "N" + q;
    return "NK" + np + nq;
}


function do_infix2praefix_konditional( p, q )
{
    var nq = q.charAt(0) === "N" ? q.substr( 1 ) : "N" + q;
    return "NK" + p + nq;
}


function do_infix2praefix_bikonditional( p, q )
{
    return "K" + do_infix2praefix_konditional( p, q ) +
                 do_infix2praefix_konditional( q, p );
}


function do_infix2praefix_negation( q )
{
    var nq = q.charAt(0) === "N" ? q.substr( 1 ) : "N" + q;
    return nq;
}


function do_infix2praefix_op()
{
    var op = pop_op(), p, q;
    switch(op)
    {
        case CGWTAB.snot: case "-": case "~":
            p = pop_val(); push_val( do_infix2praefix_negation( p ) ); break;
        case CGWTAB.sdarr: case "!":
            p = pop_val(); q = pop_val();
            push_val( do_infix2praefix_negation( do_infix2praefix_disjunktion( p, q ) ) );
            break;
        case CGWTAB.suarr: case "¡":
            p = pop_val(); q = pop_val();
            push_val( do_infix2praefix_negation( "K" + p + q ) );
            break;
        case "%":
            p = pop_val(); q = pop_val();
            push_val( "AK" + p + do_infix2praefix_negation(q) +
                       "K" + do_infix2praefix_negation(p) + q );
            break;
        case "=": case CGWTAB.sharr:
            p = pop_val(); q = pop_val();
            push_val( do_infix2praefix_bikonditional( p, q ) );
            break;
        case "&": case "^": case CGWTAB.sand:
            p = pop_val(); q = pop_val(); push_val( "K" + p + q ); break;
        case "v": case "|": case CGWTAB.sort:
            p = pop_val(); q = pop_val();
            push_val( do_infix2praefix_disjunktion( p, q ) );
            break;
        case ">": case "->": case "=>": case "-->" : case "==>":
        case CGWTAB.srarr:
            p = pop_val(); q = pop_val();
            push_val( do_infix2praefix_konditional( p, q ) );
            break;
        case ")":
            throw getMessage("Zu viele geschlossene Klammern");
        default:
            throw getMessage("OP-Fehler") + "\"" + CGWTAB.op_stapel + "\"" +
                  ", op=\"" + op + "\".";
    }
}


function infix2prefix( aussage )
{
    var i, c, resultat = "";
    CGWTAB.val_stapel.length = 0;
    CGWTAB.op_stapel.length = 0;
    try
    {
        for ( i = aussage.length-1; i >= 0; i-- )
        {                
            c = aussage.charAt(i);
            switch( c )
            {

                case " ":
                    break;
                    
                case "-": case "~": case CGWTAB.snot:
                case "!": case CGWTAB.sdarr:
                case "¡": case CGWTAB.suarr:
                case "%": case "=": case CGWTAB.sharr:
                case "&": case "^": case CGWTAB.sand:
                case "v": case "|": case CGWTAB.sor:
                case ">": case "->": case "=>": case "-->" : case "==>":
                case CGWTAB.srarr:
                    if ( c === ">" && i > 0 )
                    {
                        var d = aussage.charAt( i - 1 );
                        if ( (d === '-' || d === '=') && --i > 0 )
                        {
                            var e = aussage.charAt( i - 1 );
                            if ( e === d )
                            {
                                if ( --i > 0 && ((d = aussage.charAt(i-1)) === '-' ||
                                                 d === '=') )
                                    throw getMessage("Konditionalfehler") +
                                          (i+1);
                            }
                            else if ( e === "-" || e === "=" )
                                throw getMessage("Konditionalfehler") +
                                      (i+1);
                        }
                    }
                    if ( op_avail() && op_prio( peek_op() ) < op_prio( c ) )
                        do_infix2praefix_op();
                    push_op( c );
                    break;
                case ")":
                    push_op( c );
                    break;
                case "(":
                    while( peek_op() !== ")" )
                        do_infix2praefix_op();
                    if ( pop_op() !== ")" )
                        throw getMessage("Klammer zu erwartet");
                    break;
                default:
                    if ( ! istBuchstabe(c) && c !== '0' && c !== '1' )
                        throw getMessage("Unerlaubtes Zeichen") + " \"" + c + "\".";
                    push_val( c.toLowerCase() );
                    break;
            }
        }
        while( op_avail() )
            do_infix2praefix_op();
        resultat = pop_val();
        if ( CGWTAB.val_stapel.length !== 0 || CGWTAB.op_stapel.length !== 0 )
            throw getMessage("Stapel wird nicht leer");
        return resultat;
    }
    catch( e )
    {
        throw e;
    }
    finally
    {
        CGWTAB.val_stapel = [];
        CGWTAB.op_stapel = [];
    }
}

function openHomepage()
{
    widget.openURL( getMessage("URL") );
}


function beispielGewaehlt(event)
{
    var popupValue = document.getElementById("backExamples");
    popupValue = popupValue.object.getValue();
    
    var pfx = popupValue.substr( 0, 7 ).toLowerCase();

    if ( pfx === "example" || pfx == "beispie" )
        return;
        
    document.getElementById("aussage").value = popupValue;
    showFront(event);
    uebernehmen(event);
}


function optimierungGewaehlt(event)
{
    var popupValue = document.getElementById("backOpt");
    popupValue = popupValue.object.getValue();
    var opt = (popupValue == "1") ? 1 : 0;
    if ( opt != CGWTAB.optimize )
    {
        CGWTAB.optimize = opt;
        uebernehmen(event);
    }
}
